






      subroutine pdcosn( b,      dcosn,  nn,     nrmb,   q,      r,
     +                   root )
c     ------------------------------------------------------------------
c     pdcosn: This subroutine computes approximate cosine of directions.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c              nn    : order of the vectors.
c              root  : beginning of data structure.
c     ------------------------------------------------------------------
      integer  nn    , root

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c              b(1:nn): first vector of the angle.
c              q(1:nn): subtraction of the two vectors of the angle.
c              r(1:nn): second vector of the angle.
c     ------------------------------------------------------------------
      double precision
     +                 b(1:nn),
     +                 q(1:nn),
     +                 r(1:nn)

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c              i     : loop counter.
c     ------------------------------------------------------------------
      integer  i

c     ------------------------------------------------------------------
c     Double precision input/output variables:
c
c              dcosn : cosine between b and r.
c              nrmb  : 2-norm of b.
c     ------------------------------------------------------------------
      double precision dcosn , nrmb

c     ------------------------------------------------------------------
c     Double precision variables:
c
c              dnrm2 : 2-norm (BLAS function).
c              eps   : inner product of b and q.
c              nrmq  : 2-norm of q.
c     ------------------------------------------------------------------
      double precision dnrm2 , eps   , nrmq

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      do 10 i=1,nn
         q(i)=b(i)-r(i)
 10   continue
      nrmq= dnrm2 ( nn, q, 1)
      call pdpryx( eps,    nn,     root,   b,      q )
      dcosn = dabs(1-eps/(nrmb*nrmq))

c     ------------------------------------------------------------------
c     End of subroutine pdcosn.
c     ------------------------------------------------------------------
      return
      end
