






      subroutine pdlkst( x,      y,      parent, rank )
c     ------------------------------------------------------------------
c     pdlkst: This subroutine forms a new set that is the union of the 
c             two sets whose canonical elements are  x and y, destroying 
c             the two old sets.  select and return the canonical element 
c             of the new set. This operation assumes x != y.  This 
c             routine uses a union by rank heiristic.
c
c     ARGUMENTS:
c
c     x         canonical element in first set
c     y         canonical element in second set
c     parent()  parent array for tree representation
c     rank()    upper bound on height of element.
c
c     local variables:
c
c     c   canonical element
c
c     Reference:
c     R.E. Tarjan, "Data structures and network algorithms",SIAM,
c     Philadelphia, PA, 1983.
c
c     ------------------------------------------------------------------
c     Storage definition.
c     ------------------------------------------------------------------
      integer x,y,parent(1),rank(1)

c     ------------------------------------------------------------------
      if(rank(x).lt.rank(y)) then
         parent(x)=y
         return

      else if(rank(x).gt.rank(y)) then
         parent(y)=x
         return

      else
         parent(y)=x
         rank(x)=rank(x)+1
         return
      endif
c     ------------------------------------------------------------------
      end
