      subroutine pdpntr( na,     nn,      nwkd,  pibckt, pibpst, pibsts,
     +                   pifrst, pifthr, piifst, piinxt, pilist, pillnk,
     +                   pilost, pilsts, pimark, piofst, pionxt, pipred,
     +                   pirank, pirlnk, pirsts, pirtth, pisptr, pistdg,
     +                   pistrn, pisvtx, pitrrc, pitrth, piunxt, piw2e1,
     +                   piwke1, piwke2, piwke3, piwke4, prav01, prav03,
     +                   prav04, prav05, prav06, prav07, prav08, prdb00,
     +                   prdc00, prdiag, prdu00, prkey0, prndig, prrhs0,
     +                   prteta, prvcsd, prvcwd, prvcxd, prvcyd,
     +                   prvczd, prvczz, prvecp, prvecq, prvecr, prvecs,
     +                   prvecw, prvecx, prvecy, prvecz, prwrk1
     +                   )
c     ------------------------------------------------------------------
c     pdpntr: This subroutine distributes the auxiliary vectors over a 
c             working vector. All modifications to this subroutine 
c             must be repeated in subroutine pdwrkd.
c
c     Integer variables:
c
c            na    : number of arcs.
c            nn    : number of nodes.
c            nwkd  : size of double precision work array.
c            pibckt: pointer for bucket.
c            pibpst: pointer for bposit.
c            pibsts: pointer for bstats.
c            pifrst: pointer for first.
c            pifthr: pointer for father.
c            piifst: pointer for ifirst.
c            piinxt: pointer for innext.
c            pilist: pointer for list.
c            pillnk: pointer for link.
c            pilost: pointer for lost.
c            pilsts: pointer for lsets.
c            pimark: pointer for mark.
c            piofst: pointer for oufrst.
c            pionxt: pointer for ounext.
c            pipred: pointer for pred.
c            pirank: pointer for rank.
c            pirlnk: pointer for rlink.
c            pirsts: pointer for rsets.
c            pirtth: pointer for rtrth.
c            pisptr: pointer for stptr.
c            pistdg: pointer for stedg.
c            pistrn: pointer for strn.
c            pisvtx: pointer for stvrtx.
c            pitrrc: pointer for trearc.
c            pitrth: pointer for treath.
c            piunxt: pointer for unext.
c            piw2e1: pointer for wk2e1.
c            piwke1: pointer for wrke1.
c            piwke2: pointer for wrke2.
c            piwke3: pointer for wrke3.
c            piwke4: pointer for wrke3.
c            prav01: pointer for av1.
c            prav03: pointer for av3.
c            prav04: pointer for av4.
c            prav05: pointer for av5.
c            prav06: pointer for av6.
c            prav07: pointer for av7.
c            prav08: pointer for av8.
c            prdb00: pointer for db.
c            prdc00: pointer for dc.
c            prdiag: pointer for diag.
c            prdu00: pointer for du.
c            prkey0: pointer for key.
c            prndig: pointer for ndiag.
c            prrhs0: pointer for rhs.
c            prteta: pointer for teta.
c            prvcsd: pointer for sd.
c            prvcwd: pointer for wd.
c            prvcxd: pointer for xd.
c            prvcyd: pointer for yd.
c            prvczd: pointer for zd.
c            prvczz: pointer for zz.
c            prvecp: pointer for p.
c            prvecq: pointer for q.
c            prvecr: pointer for r.
c            prvecs: pointer for s.
c            prvecw: pointer for w.
c            prvecx: pointer for x.
c            prvecy: pointer for y.
c            prvecz: pointer for z.
c            prwrk1: pointer for wrkdv1.
c     ----------------------------------------------------------------
      integer na    , nn    , nwkd,   pibckt, pibpst, pibsts, pifrst,
     +        pifthr, piifst, piinxt, pilist, pillnk, pilost, pilsts,
     +        pimark, piofst, pionxt, pipred, pirank, pirlnk, pirsts,  
     +        pirtth, pisptr, pistdg, pistrn, pisvtx, pitrrc, pitrth,
     +        piunxt, piw2e1, piwke1, piwke2, piwke3, piwke4, prav01,
     +        prav03, prav04, prav05, prav06, prav07, prav08, prdb00,
     +        prdc00, prdiag, prdu00, prkey0, prndig, prrhs0, prteta,
     +        prvcsd, prvcwd, prvcxd, prvcyd, prvczd, prvczz,
     +        prvecp, prvecq, prvecr, prvecs, prvecw, prvecx, prvecy,
     +        prvecz, prwrk1

c     ----------------------------------------------------------------
c     Integer working variables
c   
c:          ptrd: pointer to double precision work array location
c     ----------------------------------------------------------------
      integer ptrd
      
c     Initialize double precision pointer
      ptrd = 1

c     Integer arrays
      pibpst = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pibsts = 2*ptrd - 1      
      ptrd = ptrd + int((na + 1)/2)
      
      pibckt = 2*ptrd - 1
      ptrd = ptrd + int((nn + 2)/2)
      
      pifthr = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pifrst = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      piifst = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      piinxt = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pillnk = 2*ptrd - 1
      ptrd = ptrd + int((nn + 2)/2)
      
      pilist = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pilost = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pilsts = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pimark = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      piofst = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pionxt = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pipred = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pirank = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pirlnk = 2*ptrd - 1
      ptrd = ptrd + int((nn + 2)/2)
      
      pirsts = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pirtth = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pistdg = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pisptr = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pistrn = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pisvtx = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      piwke1 = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      piw2e1 = 2*ptrd - 1
      ptrd = ptrd + int((2*na + 1)/2)
      
      piwke2 = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      piwke3 = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      piwke4 = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      pitrth = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      pitrrc = 2*ptrd - 1
      ptrd = ptrd + int((nn + 1)/2)
      
      piunxt = 2*ptrd - 1
      ptrd = ptrd + int((na + 1)/2)
      
      
      prav01 = ptrd
      ptrd = ptrd + na
      
      prav03 = ptrd
      ptrd = ptrd + na
      
      prav04 = ptrd
      ptrd = ptrd + na
      
      prav05 = ptrd
      ptrd = ptrd + na
      
      prav06 = ptrd
      ptrd = ptrd + na
      
      prav07 = ptrd
      ptrd = ptrd + na
      
      prav08 = ptrd
      ptrd = ptrd + na
      
      prdb00 = ptrd
      ptrd = ptrd + nn
      
      prdc00 = ptrd
      ptrd = ptrd + na
      
      prdiag = ptrd
      ptrd = ptrd + nn
      
      prdu00 = ptrd
      ptrd = ptrd + na
      
      prkey0 = ptrd
      ptrd = ptrd + nn + 1
      
      prndig = ptrd
      ptrd = ptrd + nn
      
      prvecp = ptrd
      ptrd = ptrd + nn
      
      prvecq = ptrd
      ptrd = ptrd + nn
      
      prrhs0 = ptrd
      ptrd = ptrd + nn
      
      prvecr = ptrd
      ptrd = ptrd + nn
      
      prvcsd = ptrd
      ptrd = ptrd + na
      
      prvecs = ptrd
      ptrd = ptrd + na
      
      prteta = ptrd
      ptrd = ptrd + na
      
      prvcwd = ptrd
      ptrd = ptrd + na
      
      prvecw = ptrd
      ptrd = ptrd + na
      
      prwrk1 = ptrd
      ptrd = ptrd + nn
      
      prvcxd = ptrd
      ptrd = ptrd + na
      
      prvcyd = ptrd
      ptrd = ptrd + nn
      
      prvecx = ptrd
      ptrd = ptrd + na
      
      prvecy = ptrd
      ptrd = ptrd + nn
      
      prvczd = ptrd
      ptrd = ptrd + na
      
      prvecz = ptrd
      ptrd = ptrd + na
      
      prvczz = ptrd
      ptrd = ptrd + nn
      

      nwkd = ptrd - 1

c     ----------------------------------------------------------------
c     End of subroutine pdpntr.
c     ----------------------------------------------------------------
      end
