






      subroutine pdsbvc( dim,    root,   x,      y,      z )
c     ------------------------------------------------------------------
c     pdsbvc: This subroutine performs the operation z=x-y. The vectors
c             x, z and y have dimension dim. This subroutine is based on
c             the dblas daxpy routine.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c              dim   : dimension of vectors.
c              root  : sets beginning of structure.
c     ------------------------------------------------------------------
      integer  dim   , root

c     ------------------------------------------------------------------
c     Double precision arrays:
c
c              x(1:dim): first vector in subtraction.
c              y(1:dim): second vector in subtraction.
c              z(1:dim): x-y.
c     ------------------------------------------------------------------
      double precision
     +                 x(1:dim),
     +                 y(1:dim),
     +                 z(1:dim)

c     ------------------------------------------------------------------
c     Integer  variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m+1.
c     ------------------------------------------------------------------
      integer  i     , m     , mp1

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
 20   m = mod(dim,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
         z(i) = x(i) - y(i)
 30   continue
      if( dim .lt. 4 ) return
 40   mp1 = m + 1
      do 50 i = mp1,dim,4
         z(i) = x(i) - y(i)
         z(i + 1) = x(i + 1) - y(i + 1)
         z(i + 2) = x(i + 2) - y(i + 2)
         z(i + 3) = x(i + 3) - y(i + 3)
 50   continue
      z(root) = 0d0

c     ------------------------------------------------------------------
c     End of subroutine pdsbvc.
c     ------------------------------------------------------------------
      end
