


      subroutine pdstat(dinfo, dobj, dof, gap, ierror, info, miu, pduit,
     +                  pobj, pof)
c     ------------------------------------------------------------------
c     pdstat: Gets output statistics from info() array
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             ierror: flags errors in input.
c             pduit : number of primal-dual iterations performed.
c     ------------------------------------------------------------------
      integer ierror, pduit
      
c     ------------------------------------------------------------------
c     Integer input/output arrays:
c
c             info  (1:30): array with statistics and parameters.
c     ------------------------------------------------------------------
      integer info(1:30)

c     ----------------------------------------------------------------
c     Double precision input/output variables:
c
c             dobj  : dual objective function value.
c             dof   : dual objective function value on tree.
c             gap   : value of the gap.
c             miu   : value of interior-point mu parameter.
c             pobj  : objective function value.
c             pof   : primal objective function value on tree.
c     ------------------------------------------------------------------
      double precision dobj, dof, gap, miu, pobj, pof

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             dinfo  (1:30): array with statistics and parameters.
c     ------------------------------------------------------------------
      double precision dinfo(1:30)

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      dobj   = dinfo( 1)
      dof    = dinfo( 2)
      gap    = dinfo( 5)
      miu    = dinfo(10)
      pduit  =  info(10)
      pobj   = dinfo(15)
      pof    = dinfo(16)
      ierror =  info(15)
 
c     ------------------------------------------------------------------
c     End of subroutine pdstat .
c     ------------------------------------------------------------------
      end
